x-env: &env
  PUID: 2000
  PGID: 2000
  TZ: ${TZ}

x-restart: &restart
  restart: unless-stopped

services:
  wireguard:
    image: linuxserver/wireguard:1.0.20210914
    container_name: wireguard
    ports:
      - "51820:51820/udp"
      # For caddy
      - "80:80"
      - "443:443"
    environment:
      INTERNAL_SUBNET: 10.10.10.0
      PEERS: rpi01,pixel4a
      <<: *env
    volumes:
      - ./wireguard:/config
      - /lib/modules:/lib/modules
    cap_add:
      - NET_ADMIN
      - SYS_MODULE
    sysctls:
      net.ipv4.conf.all.src_valid_mark: 1
    <<: *restart

  caddy:
    build: .
    container_name: caddy
    depends_on: [wireguard]
    network_mode: service:wireguard # Share wireguard VPN network
    environment:
      DOMAIN: ${DOMAIN}
      EMAIL: ${EMAIL}
      CLOUDFLARE_API_TOKEN: ${CLOUDFLARE_API_TOKEN}
      <<: *env
    volumes:
      - ./caddy/caddyfile:/etc/caddy/Caddyfile:ro
      - ./caddy/data:/data
      - ./caddy/config:/config
    <<: *restart

  fail2ban:
    image: crazymax/fail2ban:0.11.2
    container_name: fail2ban
    network_mode: host
    cap_add:
      - NET_ADMIN
      - NET_RAW
    environment:
      <<: *env
    volumes:
      - ./fail2ban/data:/data
      - /var/log:/var/log:ro
    <<: *restart
